<template>
  <div
    class="card"
    :class="editing ? 'orange' : ''"
    :id="id"
  >
    <div class="content">
      <div class="header">
        <div class="ui fluid input transparent">
          Pav.&nbsp;&nbsp;
          <input
            type="text"
            v-model="data_name"
            placeholder="Nom"
          >
        </div>
      </div>

      <div class="meta"></div>
      <div class="description">
        {{ patientsCount }} {{ patientsCount > 1 ? ' patients' : ' patient' }} dans ce pavillon
      </div>
      <br/>

      <b style="color: #898989">A commander tous les jours</b>
      <checkboxes-side-menus
        :sideMenusSelected="data_sideMenusSelected"
        @sideMenuChanged="sideMenuChanged"
      >
      </checkboxes-side-menus>

      <div class="ui small basic icon right floated buttons">
        <div
          class="ui button"
          @click="remove"
        >
          <i class="ui red trash icon"></i>
        </div>
        <div
          class="ui button"
          v-show="editing"
          @click="validateUpdate"
        >
          <i class="ui green save icon"></i>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import store from '@/store/Store'

import PatientsStore from '@/store/modules/patients/PatientsStore'
import CheckboxesSideMenus from '@/components/sideMenus/CheckboxesSideMenus'

export default {
  name: 'PavillonCard',
  store,
  props: {
    pavillon: Object
  },
  data () {
    return {
      editing: false,
      hovered: false,
      data_name: this.pavillon.name,
      data_sideMenusSelected: JSON.parse(JSON.stringify(this.pavillon.sideMenus))
    }
  },
  watch: {
    data_name () {
      this.editing = true
    },
    data_sideMenusSelected () {
      this.editing = true
    }
  },
  methods: {
    remove () {
      this.$emit('removePavillon', this.pavillon._id) // catché dans Pavillons.vue
    },
    sideMenuChanged (sideMenu) {
      // check if contains
      let contains = false
      this.data_sideMenusSelected.forEach(sms => {
        if (sms._id === sideMenu._id) {
          contains = true
        }
      })

      if (contains) {
        // suppression
        this.data_sideMenusSelected = this.data_sideMenusSelected.filter(sms => sms._id !== sideMenu._id)
      } else {
        // ajout
        this.data_sideMenusSelected.push(sideMenu)
      }
    },
    validateUpdate () {
      let updatedPavillon = {
        _id: this.pavillon._id,
        name: this.data_name,
        sideMenus: this.data_sideMenusSelected
      }

      store.dispatch('PavillonsStore/updatePavillon', updatedPavillon)
        .then((response) => {
          this.editing = false
          this.$toastr.s('Pav. ' + updatedPavillon.name + ' bien modifié')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    }
  },
  computed: {
    id () {
      return 'pavilloncard' + Math.floor(Math.random() * 100000)
    },
    patientsCount () {
      return PatientsStore.getters.countFromPavillon(PatientsStore.state, this.pavillon._id)
    }
  },
  components: {
    CheckboxesSideMenus
  }
}
</script>
